#!~/virtualenv-1.9/myEV/bin/python
# encoding=utf-8

import urllib2
from BeautifulSoup import BeautifulSoup
#sys.path.append('/nlp/corpora/programy/justext')
#import justext # we use a bit modified justext module
import justext.core as jt


def getHtml(url):
    return urllib2.urlopen(url).read()


def getInformationContent(page, isWiki=False):
    """ For a webpage (html) finds text content and content images.
    """
    page = page.replace('\n', ' ')
    paragraphs = jt.justext(page, jt.get_stoplist('Czech'), \
            max_link_density=0.4)
    contentParts = []
    keywords = []
    #print json.dumps(paragraphs, indent=2)
    for paragraph in paragraphs:
        if paragraph['class'] == 'good':
            # pick titles from <a> tags as keywords
            for href, title in paragraph['links']:
                title = title.replace(u' (stránka neexistuje)', '')
                keywords.append(title.encode('utf-8'))
            # join text nodes into one piece of text
            for node in paragraph['text_nodes']:
                if node[0] not in ',;.?!:)]}':
                    contentParts.append(' ')
                contentParts.append(node)
            if paragraph['text'][-1] not in '.?!':
                contentParts.append('.')
    content = "".join(contentParts)[1:]
    content = content.encode('utf-8')
    # error correction (for testing purposes)
    #content = content.replace("vrthl", "vtrhl")
    #content = content.replace('\n', ' ')

    # find images in wiki pages
    images = []
    # TODO odstranit entity systematicky
    # TODO vyporadat se s kodovanim nejak normalne
    try:
        page = unicode(page, 'utf-8')
    except UnicodeDecodeError:
        try:
            page = unicode(page, 'windows-1250')
            page = page.replace('windows-1250', 'utf-8') # kvuli BeautfiulSoup?
        except UnicodeDecodeError:
            print 'nic'
            page = u'' # co uz
    page = page.replace(u'&#160;', u' ')
    soup = BeautifulSoup(page)
    if isWiki:
        for figDiv in soup.findAll('div', attrs={'class':'thumbinner'}):
            captionDiv = figDiv.find('div', attrs={'class':'thumbcaption'})
            if captionDiv:
                textPieces = captionDiv.findAll(text=True)
                t = textPieces[1]
                textPieces = [unicode(t) for t in textPieces]
                caption = u''.join(textPieces).strip()
                src = 'http:' + figDiv.a.img['src']
                images.append((caption, src))

    # TODO find images in non-wiki pages
    return (content, keywords, images)

if __name__ == '__main__':
    URL = 'http://cs.wikipedia.org/wiki/Husitsk%C3%A9_v%C3%A1lky'
    print getInformationContent(URL)
