#!~/virtualenv-1.9/myEV/bin/python                                              
# encoding=utf-8

from __future__ import unicode_literals
import sys
sys.path.insert(0,'/home/xeffenb1/procvicnik')
sys.path.append('home/xeffenb1/procvicnik/tools')
from jinja2 import Template
from urlparse import urlparse, parse_qs
from ontology import createOntology, createOntologyFromText
from exercises import createExercises, createExercisesFromTranslations
import json

#TEMPLATE_DIR = 'www/templates/'
#
#def renderTemplate(templateFileName, **kwargs):
#    with open(TEMPLATE_DIR + templateFileName) as f:
#        template = Template(f.read().decode('utf-8'))
#    return template.render(kwargs)


def exercisesFromUrl(url):
        ontology, bigrams = createOntology(url)
        exercises = createExercises(ontology, bigrams)
        print json.dumps([e.__dict__ for e in exercises],indent=1)


def tryExercisesFromUrl():
    #URL = 'http://cs.wikipedia.org/wiki/USA'
    URL = 'http://cs.wikipedia.org/wiki/Husitsk%C3%A9_v%C3%A1lky'
    exercisesFromUrl(URL)


def exercisesFromFile(inputFile, outputFile, translations=False):
    with open(inputFile) as f:
        text = (f.read())
    ontology, bigrams = createOntologyFromText(text, isWiki=True, \
            translations=translations)
    if translations:
        exercises = createExercisesFromTranslations(ontology)
    else:
        exercises = createExercises(ontology, bigrams, maxQuestions=150)
    with open(outputFile, 'w') as f:
        f.write(json.dumps([e.__dict__ for e in exercises],indent=1))

def tryExercisesFromFile(translations=False):
    INPUT_FILE = 'data/mishmash.txt'
    OUTPUT_FILE = 'data/mishmash.exercises'
    exercisesFromFile(INPUT_FILE, OUTPUT_FILE, translations)


if __name__ == '__main__':
    tryExercisesFromFile(translations=True)
