// global variables
var exercises = []
var currentExercise = {}
var answered = true;
var answer = -1;

// ---------------------------------------------------------
//  Event handlers
// ---------------------------------------------------------

function nextExerciseClick() {
    if (!example) {
        logAnswer();
    }
    newExercise();
}

function answerClick() {
    if (answered) {
        return;
    }
    answered = true;
    evaluateAnswer(this);
}


// ----------------------------------------------------------
//  Ajax callbacks
// ----------------------------------------------------------
function exercisesDelivered(response) {
    console.log(response);
    exercises = response;
    newExercise();
}

function updateExerciseList(response) {
    // TODO aktualizovani seznamu otazek    
}


// ----------------------------------------------------------
//  Exercise session actions 
// ----------------------------------------------------------

function startExerciseSession() {
    if (!example) {
        $.ajax({
            url: "/interface/create-ontology",
            type: "POST",
            datatype: "json",
            data: JSON.stringify({"url":url}),
            success: exercisesDelivered
        });
    } else {
        $.ajax({
            url: "/interface/example",
            type: "POST",
            datatype: "json",
            data: JSON.stringify({"exercise-type":example}),
            success: exercisesDelivered
        });
    }
}

//TODO parsovani sablon jen 1x
//TODO pro pristup k elementum DOMu pouzivat promenne, nehledat pokazde znova
function newExercise() {
    if (exercises.length == 0) {
        var t = $("#exercisesCompletedTemplate").html();
        Mustache.parse(t);
        var r = Mustache.render(t, {});
        $("#exercise-wrapper").html(r);
        return;
    }
    currentExercise = exercises.pop();
    var t = $("#exerciseTemplate").html();
    Mustache.parse(t);
    currentExercise.notExample = !example;
    var r = Mustache.render(t, currentExercise);
    $("#exercise-wrapper").html(r);
    $("#exercise .choices .button.active").click(answerClick);
    $("#new-exercise").click(nextExerciseClick);
    answered = false;
    if (currentExercise.googleMapPoints) {
        loadMap();
    }
}


function loadMap() {
    script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = 'https://maps.googleapis.com/maps/api/js' +
        '?v=3.exp&sensor=false&callback=initializeMap';
    document.body.appendChild(script);
}


function initializeMap() {
    var points = currentExercise.googleMapPoints;
    var mapOptions = {
        //center: {lat: 50.0286, lng: 14.9369},
        //zoom: 7,
        disableDefaultUI: true,
        scrollwheel: false,
        navigationControl: false,
        mapTypeControl: false,
        scaleControl: false,
        draggable: false,
        zoomControl: false,
        scrollWhee: false,
        disableDoubleClickZoom: true,
        mapTypeId: google.maps.MapTypeId.TERRAIN
    };

    var map = new google.maps.Map(document.getElementById("map-canvas"),
    mapOptions);

    // create markers
    var letters = ['A', 'B', 'C', 'D'];
    for (var i=0; i < 4; i++) {
        var iconUrl = 'http://chart.apis.google.com/chart' + 
            '?chst=d_map_pin_letter&chld=' + letters[i] + '|FE6256|000000';
        var point = points[i];
        var marker = new google.maps.Marker({
            position: {lat: point[0], lng: point[1]},
            map: map,
            icon: iconUrl,
            title: letters[i]
        });
    }

    // fit view to markers
    var bounds = new google.maps.LatLngBounds();
    for (var i = 0; i < points.length; i++) {
        bounds.extend(new google.maps.LatLng(points[i][0], points[i][1]));
    }
    map.fitBounds(bounds);
}


function evaluateAnswer(clickedButton) {
    $buttons = $("#exercise .choices .button");
    answer = $buttons.index(clickedButton);
    $buttons.removeClass("active");
    $buttons.unbind("click");
    var correct = (answer == currentExercise.correctAnswer);
    if (correct) {
        $("#result").addClass("positive").text("Správně");
    } else {
        $($buttons.get(answer)).addClass("wrong");
        $("#result").addClass("negative").text("Špatně");
    }
    $($buttons.get(currentExercise.correctAnswer)).addClass("correct");
}


/**
 * Send exercise, answer and feedback to the server.
 */
function logAnswer() {
    currentExercise.timestamp = $.now();
    if (!answered) {
        answer = -1;
    }
    currentExercise.answer = answer;
    currentExercise.url = url; 
    currentExercise.nonsence = $("#feedback-nonsence").is(':checked');
    currentExercise.grammarError = $("#feedback-grammar").is(':checked');
    currentExercise.nonrelevant = $("#feedback-relevance").is(':checked');
    currentExercise.difficult = $("#feedback-difficult").is(':checked');
    currentExercise.easy = $("#feedback-easy").is(':checked');
    currentExercise.badAnswers = $("#feedback-bad-answers").is(':checked');
    currentExercise.great = $("#feedback-great").is(':checked');

    // TODO pri posilani info o cviceni dostat zpatky nejnovejsi verzi 
    // haldy (resp. uz serazenych cviceni)
    $.ajax({
        url: "/interface/exercise-done",
        type: 'POST',
        datatype: "json",
        data: JSON.stringify({"exercise": currentExercise}),
        success: updateExerciseList
    });

    console.log(currentExercise); 
}


function showProcessingWheel() {
    var t = $("#processingTemplate").html();
    Mustache.parse(t);
    var r = Mustache.render(t, {});
    $("#exercise-wrapper").html(r)
}






